import usb
from ctypes import *
import time
import os

####################################

VENDOR_RQ_GET_LIGHT0 = 6
VENDOR_RQ_GET_LIGHT1 = 7
VENDOR_RQ_GET_LIGHT2 = 2
VENDOR_RQ_GET_LIGHT3 = 3
VENDOR_RQ_GET_LIGHT4 = 4
VENDOR_RQ_GET_LIGHT5 = 5
####################################

class Board:

    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def get_light0(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT0, 2)
        return buf[1]*256+buf[0]
    def get_light1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT1, 2)
        return buf[1]*256+buf[0]
    def get_light2(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT2, 2)
        return buf[1]*256+buf[0]
    def get_light3(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT3, 2)
        return buf[1]*256+buf[0]
    def get_light4(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT4, 2)
        return buf[1]*256+buf[0]
    def get_light5(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT5, 2)
        return buf[1]*256+buf[0]

if os.name == 'posix':
    Xtst = CDLL("libXtst.so.6")
    Xlib = CDLL("libX11.so.6")
    dpy = Xtst.XOpenDisplay(None)
    def SendInput( txt ):
        for c in txt:
            sym = Xlib.XStringToKeysym(c)
            code = Xlib.XKeysymToKeycode(dpy, sym)
            Xtst.XTestFakeKeyEvent(dpy, code, True, 0)
            Xtst.XTestFakeKeyEvent(dpy, code, False, 0)
        Xlib.XFlush(dpy)

    def SendKeyPress(key):
        sym = Xlib.XStringToKeysym(str(key))
        code = Xlib.XKeysymToKeycode(dpy, sym)
        Xtst.XTestFakeKeyEvent(dpy, code, True, 0)
        Xlib.XFlush(dpy)

    def SendKeyRelease(key):
        sym = Xlib.XStringToKeysym(str(key))
        code = Xlib.XKeysymToKeycode(dpy, sym)
        Xtst.XTestFakeKeyEvent(dpy, code, False, 0)
        Xlib.XFlush(dpy)
    def escape(x):
	esc = Xlib.XKeysymToKeycode(dpy,0xff1B)
        Xtst.XTestFakeKeyEvent(dpy, esc, x, 0)
        Xlib.XFlush(dpy)
    def left(x):
	left = Xlib.XKeysymToKeycode(dpy,0xff51)
        Xtst.XTestFakeKeyEvent(dpy, left, x, 0)
        Xlib.XFlush(dpy)
    def up(x):
	up = Xlib.XKeysymToKeycode(dpy,0xff52)
        Xtst.XTestFakeKeyEvent(dpy, up, x, 0)
        Xlib.XFlush(dpy)
    def right(x):
	right = Xlib.XKeysymToKeycode(dpy,0xff53)
        Xtst.XTestFakeKeyEvent(dpy, right, x, 0)
        Xlib.XFlush(dpy)
    def down(x):
	down = Xlib.XKeysymToKeycode(dpy,0xff54)
        Xtst.XTestFakeKeyEvent(dpy, down, x, 0)
        Xlib.XFlush(dpy)

b =Board()
while(1):
 if(b.get_light1()<=300):
  escape(True);
 if(b.get_light1()>300):
  escape(False);
 if(b.get_light3()<=350):
  SendKeyPress('z');
 if(b.get_light3()>350):
  SendKeyRelease('z');
 if(b.get_light2()<=350):
  left(True);
 if(b.get_light2()>350):
  left(False);
 if(b.get_light0()<=350):
  up(True);
 if(b.get_light0()>350):
  up(False);
 if(b.get_light4()<=350):
  right(True);
 if(b.get_light4()>350):
  right(False);
 if(b.get_light5()<=350):
  down(True);
 if(b.get_light5()>350):
  down(False);
